#!/usr/bin/perl -T

use strict;
use warnings;
use Jcode;
use CGI qw(:standard);

my $kanjicode = 'Shift_JIS';

# --------------------------------------
print header(-charset => 'Shift_JIS');
print start_html('LEԂϊCGI');
print h1({-align => 'center'}, 'LEԂϊCGI');
print hr;

if (param('mycmd') eq 'convert') {
    &do_convert;
} else {
    &do_form;
}
exit(0);

# --------------------------------------
sub do_form {
    print startform(
        -method => 'POST',
        -action => 'neko1.cgi'
    );

    print h3('Ił:');
    print blockquote(
        radio_group(
            -name => 'mytype',
            -values => [ 'L', 'Ԃ' ],
            -default => 'L',
            -linebreak => 'true',
        )
    );

    print h3('͂͂Ă:');
    print blockquote(
        textarea(
            -name => 'mymsg',
            -rows => '5',
            -columns => '40'
        )
    );
    print br;
    print submit(-value => 'ϊ');
    print reset;
    print hidden(
        -name => 'mycmd',
        -value => 'convert'
    );
    print endform;
    print end_html;
}

# --------------------------------------
sub do_convert {
    my $msg = param('mymsg');
    Jcode::convert(\$msg, $kanjicode);
    print h2('Ƃ̕');
    print blockquote(pre($msg));
    print h2('ϊ̕');
    my $result;
    if (param('mytype') eq 'L') {
        $result = &nekoize($msg);
    } else {
        $result = &akatyanize($msg);
    }
    print blockquote(pre($result));
    print hr;
    print ul(
        li(
            a(
                { href => url() },
                'x'
            )
        )
    );
    print end_html;
}

# --------------------------------------
sub nekoize {
    my ($s) = @_;
    $s =~ s//ɂ/g;
    $s =~ s//ɂ/g;
    $s =~ s//ɂ/g;
    $s =~ s/B/ɂB/g;
    return $s;
}

# --------------------------------------
sub akatyanize {
    my ($s) = @_;
    $s =~ s///g;
    $s =~ s///g;
    $s =~ s///g;
    $s =~ s///g;
    $s =~ s///g;
    return $s;
}
